<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountCommunication Array
 * @subpackage Arrays
 */
class ArrayOfAccountCommunication extends AbstractStructArrayBase
{
    /**
     * The AccountCommunication
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\AccountCommunication[]
     */
    public $AccountCommunication;
    /**
     * Constructor method for ArrayOfAccountCommunication
     * @uses ArrayOfAccountCommunication::setAccountCommunication()
     * @param \SGCIS\Struct\AccountCommunication[] $accountCommunication
     */
    public function __construct(array $accountCommunication = array())
    {
        $this
            ->setAccountCommunication($accountCommunication);
    }
    /**
     * Get AccountCommunication value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\AccountCommunication[]|null
     */
    public function getAccountCommunication()
    {
        return isset($this->AccountCommunication) ? $this->AccountCommunication : null;
    }
    /**
     * Set AccountCommunication value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\AccountCommunication[] $accountCommunication
     * @return \SGCIS\Array\ArrayOfAccountCommunication
     */
    public function setAccountCommunication(array $accountCommunication = array())
    {
        foreach ($accountCommunication as $arrayOfAccountCommunicationAccountCommunicationItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountCommunicationAccountCommunicationItem instanceof \SGCIS\Struct\AccountCommunication) {
                throw new \InvalidArgumentException(sprintf('The AccountCommunication property can only contain items of \SGCIS\Struct\AccountCommunication, "%s" given', is_object($arrayOfAccountCommunicationAccountCommunicationItem) ? get_class($arrayOfAccountCommunicationAccountCommunicationItem) : gettype($arrayOfAccountCommunicationAccountCommunicationItem)), __LINE__);
            }
        }
        if (is_null($accountCommunication) || (is_array($accountCommunication) && empty($accountCommunication))) {
            unset($this->AccountCommunication);
        } else {
            $this->AccountCommunication = $accountCommunication;
        }
        return $this;
    }
    /**
     * Add item to AccountCommunication value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\AccountCommunication $item
     * @return \SGCIS\Array\ArrayOfAccountCommunication
     */
    public function addToAccountCommunication(\SGCIS\Struct\AccountCommunication $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\AccountCommunication) {
            throw new \InvalidArgumentException(sprintf('The AccountCommunication property can only contain items of \SGCIS\Struct\AccountCommunication, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AccountCommunication[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\AccountCommunication|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\AccountCommunication|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\AccountCommunication|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\AccountCommunication|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\AccountCommunication|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountCommunication
     */
    public function getAttributeName()
    {
        return 'AccountCommunication';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfAccountCommunication
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
