<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBillPaymentAdjustmentDetail Array
 * @subpackage Arrays
 */
class ArrayOfBillPaymentAdjustmentDetail extends AbstractStructArrayBase
{
    /**
     * The BillPaymentAdjustmentDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\BillPaymentAdjustmentDetail[]
     */
    public $BillPaymentAdjustmentDetail;
    /**
     * Constructor method for ArrayOfBillPaymentAdjustmentDetail
     * @uses ArrayOfBillPaymentAdjustmentDetail::setBillPaymentAdjustmentDetail()
     * @param \SGCIS\Struct\BillPaymentAdjustmentDetail[] $billPaymentAdjustmentDetail
     */
    public function __construct(array $billPaymentAdjustmentDetail = array())
    {
        $this
            ->setBillPaymentAdjustmentDetail($billPaymentAdjustmentDetail);
    }
    /**
     * Get BillPaymentAdjustmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail[]|null
     */
    public function getBillPaymentAdjustmentDetail()
    {
        return isset($this->BillPaymentAdjustmentDetail) ? $this->BillPaymentAdjustmentDetail : null;
    }
    /**
     * Set BillPaymentAdjustmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\BillPaymentAdjustmentDetail[] $billPaymentAdjustmentDetail
     * @return \SGCIS\Array\ArrayOfBillPaymentAdjustmentDetail
     */
    public function setBillPaymentAdjustmentDetail(array $billPaymentAdjustmentDetail = array())
    {
        foreach ($billPaymentAdjustmentDetail as $arrayOfBillPaymentAdjustmentDetailBillPaymentAdjustmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfBillPaymentAdjustmentDetailBillPaymentAdjustmentDetailItem instanceof \SGCIS\Struct\BillPaymentAdjustmentDetail) {
                throw new \InvalidArgumentException(sprintf('The BillPaymentAdjustmentDetail property can only contain items of \SGCIS\Struct\BillPaymentAdjustmentDetail, "%s" given', is_object($arrayOfBillPaymentAdjustmentDetailBillPaymentAdjustmentDetailItem) ? get_class($arrayOfBillPaymentAdjustmentDetailBillPaymentAdjustmentDetailItem) : gettype($arrayOfBillPaymentAdjustmentDetailBillPaymentAdjustmentDetailItem)), __LINE__);
            }
        }
        if (is_null($billPaymentAdjustmentDetail) || (is_array($billPaymentAdjustmentDetail) && empty($billPaymentAdjustmentDetail))) {
            unset($this->BillPaymentAdjustmentDetail);
        } else {
            $this->BillPaymentAdjustmentDetail = $billPaymentAdjustmentDetail;
        }
        return $this;
    }
    /**
     * Add item to BillPaymentAdjustmentDetail value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\BillPaymentAdjustmentDetail $item
     * @return \SGCIS\Array\ArrayOfBillPaymentAdjustmentDetail
     */
    public function addToBillPaymentAdjustmentDetail(\SGCIS\Struct\BillPaymentAdjustmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\BillPaymentAdjustmentDetail) {
            throw new \InvalidArgumentException(sprintf('The BillPaymentAdjustmentDetail property can only contain items of \SGCIS\Struct\BillPaymentAdjustmentDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BillPaymentAdjustmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\BillPaymentAdjustmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BillPaymentAdjustmentDetail
     */
    public function getAttributeName()
    {
        return 'BillPaymentAdjustmentDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfBillPaymentAdjustmentDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
