<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBillServicePointBillingException Array
 * @subpackage Arrays
 */
class ArrayOfBillServicePointBillingException extends AbstractStructArrayBase
{
    /**
     * The BillServicePointBillingException
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\BillServicePointBillingException[]
     */
    public $BillServicePointBillingException;
    /**
     * Constructor method for ArrayOfBillServicePointBillingException
     * @uses ArrayOfBillServicePointBillingException::setBillServicePointBillingException()
     * @param \SGCIS\Struct\BillServicePointBillingException[] $billServicePointBillingException
     */
    public function __construct(array $billServicePointBillingException = array())
    {
        $this
            ->setBillServicePointBillingException($billServicePointBillingException);
    }
    /**
     * Get BillServicePointBillingException value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\BillServicePointBillingException[]|null
     */
    public function getBillServicePointBillingException()
    {
        return isset($this->BillServicePointBillingException) ? $this->BillServicePointBillingException : null;
    }
    /**
     * Set BillServicePointBillingException value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\BillServicePointBillingException[] $billServicePointBillingException
     * @return \SGCIS\Array\ArrayOfBillServicePointBillingException
     */
    public function setBillServicePointBillingException(array $billServicePointBillingException = array())
    {
        foreach ($billServicePointBillingException as $arrayOfBillServicePointBillingExceptionBillServicePointBillingExceptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfBillServicePointBillingExceptionBillServicePointBillingExceptionItem instanceof \SGCIS\Struct\BillServicePointBillingException) {
                throw new \InvalidArgumentException(sprintf('The BillServicePointBillingException property can only contain items of \SGCIS\Struct\BillServicePointBillingException, "%s" given', is_object($arrayOfBillServicePointBillingExceptionBillServicePointBillingExceptionItem) ? get_class($arrayOfBillServicePointBillingExceptionBillServicePointBillingExceptionItem) : gettype($arrayOfBillServicePointBillingExceptionBillServicePointBillingExceptionItem)), __LINE__);
            }
        }
        if (is_null($billServicePointBillingException) || (is_array($billServicePointBillingException) && empty($billServicePointBillingException))) {
            unset($this->BillServicePointBillingException);
        } else {
            $this->BillServicePointBillingException = $billServicePointBillingException;
        }
        return $this;
    }
    /**
     * Add item to BillServicePointBillingException value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\BillServicePointBillingException $item
     * @return \SGCIS\Array\ArrayOfBillServicePointBillingException
     */
    public function addToBillServicePointBillingException(\SGCIS\Struct\BillServicePointBillingException $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\BillServicePointBillingException) {
            throw new \InvalidArgumentException(sprintf('The BillServicePointBillingException property can only contain items of \SGCIS\Struct\BillServicePointBillingException, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BillServicePointBillingException[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\BillServicePointBillingException|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\BillServicePointBillingException|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\BillServicePointBillingException|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\BillServicePointBillingException|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\BillServicePointBillingException|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BillServicePointBillingException
     */
    public function getAttributeName()
    {
        return 'BillServicePointBillingException';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfBillServicePointBillingException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
