<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCharge Array
 * @subpackage Arrays
 */
class ArrayOfCharge extends AbstractStructArrayBase
{
    /**
     * The Charge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\Charge[]
     */
    public $Charge;
    /**
     * Constructor method for ArrayOfCharge
     * @uses ArrayOfCharge::setCharge()
     * @param \SGCIS\Struct\Charge[] $charge
     */
    public function __construct(array $charge = array())
    {
        $this
            ->setCharge($charge);
    }
    /**
     * Get Charge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\Charge[]|null
     */
    public function getCharge()
    {
        return isset($this->Charge) ? $this->Charge : null;
    }
    /**
     * Set Charge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\Charge[] $charge
     * @return \SGCIS\Array\ArrayOfCharge
     */
    public function setCharge(array $charge = array())
    {
        foreach ($charge as $arrayOfChargeChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfChargeChargeItem instanceof \SGCIS\Struct\Charge) {
                throw new \InvalidArgumentException(sprintf('The Charge property can only contain items of \SGCIS\Struct\Charge, "%s" given', is_object($arrayOfChargeChargeItem) ? get_class($arrayOfChargeChargeItem) : gettype($arrayOfChargeChargeItem)), __LINE__);
            }
        }
        if (is_null($charge) || (is_array($charge) && empty($charge))) {
            unset($this->Charge);
        } else {
            $this->Charge = $charge;
        }
        return $this;
    }
    /**
     * Add item to Charge value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\Charge $item
     * @return \SGCIS\Array\ArrayOfCharge
     */
    public function addToCharge(\SGCIS\Struct\Charge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\Charge) {
            throw new \InvalidArgumentException(sprintf('The Charge property can only contain items of \SGCIS\Struct\Charge, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Charge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\Charge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\Charge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\Charge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\Charge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\Charge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Charge
     */
    public function getAttributeName()
    {
        return 'Charge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
