<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistributionServiceProvider Array
 * @subpackage Arrays
 */
class ArrayOfDistributionServiceProvider extends AbstractStructArrayBase
{
    /**
     * The DistributionServiceProvider
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\DistributionServiceProvider[]
     */
    public $DistributionServiceProvider;
    /**
     * Constructor method for ArrayOfDistributionServiceProvider
     * @uses ArrayOfDistributionServiceProvider::setDistributionServiceProvider()
     * @param \SGCIS\Struct\DistributionServiceProvider[] $distributionServiceProvider
     */
    public function __construct(array $distributionServiceProvider = array())
    {
        $this
            ->setDistributionServiceProvider($distributionServiceProvider);
    }
    /**
     * Get DistributionServiceProvider value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\DistributionServiceProvider[]|null
     */
    public function getDistributionServiceProvider()
    {
        return isset($this->DistributionServiceProvider) ? $this->DistributionServiceProvider : null;
    }
    /**
     * Set DistributionServiceProvider value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\DistributionServiceProvider[] $distributionServiceProvider
     * @return \SGCIS\Array\ArrayOfDistributionServiceProvider
     */
    public function setDistributionServiceProvider(array $distributionServiceProvider = array())
    {
        foreach ($distributionServiceProvider as $arrayOfDistributionServiceProviderDistributionServiceProviderItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistributionServiceProviderDistributionServiceProviderItem instanceof \SGCIS\Struct\DistributionServiceProvider) {
                throw new \InvalidArgumentException(sprintf('The DistributionServiceProvider property can only contain items of \SGCIS\Struct\DistributionServiceProvider, "%s" given', is_object($arrayOfDistributionServiceProviderDistributionServiceProviderItem) ? get_class($arrayOfDistributionServiceProviderDistributionServiceProviderItem) : gettype($arrayOfDistributionServiceProviderDistributionServiceProviderItem)), __LINE__);
            }
        }
        if (is_null($distributionServiceProvider) || (is_array($distributionServiceProvider) && empty($distributionServiceProvider))) {
            unset($this->DistributionServiceProvider);
        } else {
            $this->DistributionServiceProvider = $distributionServiceProvider;
        }
        return $this;
    }
    /**
     * Add item to DistributionServiceProvider value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\DistributionServiceProvider $item
     * @return \SGCIS\Array\ArrayOfDistributionServiceProvider
     */
    public function addToDistributionServiceProvider(\SGCIS\Struct\DistributionServiceProvider $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\DistributionServiceProvider) {
            throw new \InvalidArgumentException(sprintf('The DistributionServiceProvider property can only contain items of \SGCIS\Struct\DistributionServiceProvider, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DistributionServiceProvider[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\DistributionServiceProvider|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\DistributionServiceProvider|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\DistributionServiceProvider|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\DistributionServiceProvider|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\DistributionServiceProvider|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistributionServiceProvider
     */
    public function getAttributeName()
    {
        return 'DistributionServiceProvider';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfDistributionServiceProvider
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
