<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHistoricalConsumptionUsageReport Array
 * @subpackage Arrays
 */
class ArrayOfHistoricalConsumptionUsageReport extends AbstractStructArrayBase
{
    /**
     * The HistoricalConsumptionUsageReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\HistoricalConsumptionUsageReport[]
     */
    public $HistoricalConsumptionUsageReport;
    /**
     * Constructor method for ArrayOfHistoricalConsumptionUsageReport
     * @uses ArrayOfHistoricalConsumptionUsageReport::setHistoricalConsumptionUsageReport()
     * @param \SGCIS\Struct\HistoricalConsumptionUsageReport[] $historicalConsumptionUsageReport
     */
    public function __construct(array $historicalConsumptionUsageReport = array())
    {
        $this
            ->setHistoricalConsumptionUsageReport($historicalConsumptionUsageReport);
    }
    /**
     * Get HistoricalConsumptionUsageReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport[]|null
     */
    public function getHistoricalConsumptionUsageReport()
    {
        return isset($this->HistoricalConsumptionUsageReport) ? $this->HistoricalConsumptionUsageReport : null;
    }
    /**
     * Set HistoricalConsumptionUsageReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\HistoricalConsumptionUsageReport[] $historicalConsumptionUsageReport
     * @return \SGCIS\Array\ArrayOfHistoricalConsumptionUsageReport
     */
    public function setHistoricalConsumptionUsageReport(array $historicalConsumptionUsageReport = array())
    {
        foreach ($historicalConsumptionUsageReport as $arrayOfHistoricalConsumptionUsageReportHistoricalConsumptionUsageReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfHistoricalConsumptionUsageReportHistoricalConsumptionUsageReportItem instanceof \SGCIS\Struct\HistoricalConsumptionUsageReport) {
                throw new \InvalidArgumentException(sprintf('The HistoricalConsumptionUsageReport property can only contain items of \SGCIS\Struct\HistoricalConsumptionUsageReport, "%s" given', is_object($arrayOfHistoricalConsumptionUsageReportHistoricalConsumptionUsageReportItem) ? get_class($arrayOfHistoricalConsumptionUsageReportHistoricalConsumptionUsageReportItem) : gettype($arrayOfHistoricalConsumptionUsageReportHistoricalConsumptionUsageReportItem)), __LINE__);
            }
        }
        if (is_null($historicalConsumptionUsageReport) || (is_array($historicalConsumptionUsageReport) && empty($historicalConsumptionUsageReport))) {
            unset($this->HistoricalConsumptionUsageReport);
        } else {
            $this->HistoricalConsumptionUsageReport = $historicalConsumptionUsageReport;
        }
        return $this;
    }
    /**
     * Add item to HistoricalConsumptionUsageReport value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\HistoricalConsumptionUsageReport $item
     * @return \SGCIS\Array\ArrayOfHistoricalConsumptionUsageReport
     */
    public function addToHistoricalConsumptionUsageReport(\SGCIS\Struct\HistoricalConsumptionUsageReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\HistoricalConsumptionUsageReport) {
            throw new \InvalidArgumentException(sprintf('The HistoricalConsumptionUsageReport property can only contain items of \SGCIS\Struct\HistoricalConsumptionUsageReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HistoricalConsumptionUsageReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\HistoricalConsumptionUsageReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HistoricalConsumptionUsageReport
     */
    public function getAttributeName()
    {
        return 'HistoricalConsumptionUsageReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfHistoricalConsumptionUsageReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
