<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMonthlyBillingCycle Array
 * @subpackage Arrays
 */
class ArrayOfMonthlyBillingCycle extends AbstractStructArrayBase
{
    /**
     * The MonthlyBillingCycle
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\MonthlyBillingCycle[]
     */
    public $MonthlyBillingCycle;
    /**
     * Constructor method for ArrayOfMonthlyBillingCycle
     * @uses ArrayOfMonthlyBillingCycle::setMonthlyBillingCycle()
     * @param \SGCIS\Struct\MonthlyBillingCycle[] $monthlyBillingCycle
     */
    public function __construct(array $monthlyBillingCycle = array())
    {
        $this
            ->setMonthlyBillingCycle($monthlyBillingCycle);
    }
    /**
     * Get MonthlyBillingCycle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\MonthlyBillingCycle[]|null
     */
    public function getMonthlyBillingCycle()
    {
        return isset($this->MonthlyBillingCycle) ? $this->MonthlyBillingCycle : null;
    }
    /**
     * Set MonthlyBillingCycle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\MonthlyBillingCycle[] $monthlyBillingCycle
     * @return \SGCIS\Array\ArrayOfMonthlyBillingCycle
     */
    public function setMonthlyBillingCycle(array $monthlyBillingCycle = array())
    {
        foreach ($monthlyBillingCycle as $arrayOfMonthlyBillingCycleMonthlyBillingCycleItem) {
            // validation for constraint: itemType
            if (!$arrayOfMonthlyBillingCycleMonthlyBillingCycleItem instanceof \SGCIS\Struct\MonthlyBillingCycle) {
                throw new \InvalidArgumentException(sprintf('The MonthlyBillingCycle property can only contain items of \SGCIS\Struct\MonthlyBillingCycle, "%s" given', is_object($arrayOfMonthlyBillingCycleMonthlyBillingCycleItem) ? get_class($arrayOfMonthlyBillingCycleMonthlyBillingCycleItem) : gettype($arrayOfMonthlyBillingCycleMonthlyBillingCycleItem)), __LINE__);
            }
        }
        if (is_null($monthlyBillingCycle) || (is_array($monthlyBillingCycle) && empty($monthlyBillingCycle))) {
            unset($this->MonthlyBillingCycle);
        } else {
            $this->MonthlyBillingCycle = $monthlyBillingCycle;
        }
        return $this;
    }
    /**
     * Add item to MonthlyBillingCycle value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\MonthlyBillingCycle $item
     * @return \SGCIS\Array\ArrayOfMonthlyBillingCycle
     */
    public function addToMonthlyBillingCycle(\SGCIS\Struct\MonthlyBillingCycle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\MonthlyBillingCycle) {
            throw new \InvalidArgumentException(sprintf('The MonthlyBillingCycle property can only contain items of \SGCIS\Struct\MonthlyBillingCycle, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MonthlyBillingCycle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\MonthlyBillingCycle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\MonthlyBillingCycle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\MonthlyBillingCycle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\MonthlyBillingCycle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\MonthlyBillingCycle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MonthlyBillingCycle
     */
    public function getAttributeName()
    {
        return 'MonthlyBillingCycle';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfMonthlyBillingCycle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
