<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentArrangementReceivable Array
 * @subpackage Arrays
 */
class ArrayOfPaymentArrangementReceivable extends AbstractStructArrayBase
{
    /**
     * The PaymentArrangementReceivable
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\PaymentArrangementReceivable[]
     */
    public $PaymentArrangementReceivable;
    /**
     * Constructor method for ArrayOfPaymentArrangementReceivable
     * @uses ArrayOfPaymentArrangementReceivable::setPaymentArrangementReceivable()
     * @param \SGCIS\Struct\PaymentArrangementReceivable[] $paymentArrangementReceivable
     */
    public function __construct(array $paymentArrangementReceivable = array())
    {
        $this
            ->setPaymentArrangementReceivable($paymentArrangementReceivable);
    }
    /**
     * Get PaymentArrangementReceivable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\PaymentArrangementReceivable[]|null
     */
    public function getPaymentArrangementReceivable()
    {
        return isset($this->PaymentArrangementReceivable) ? $this->PaymentArrangementReceivable : null;
    }
    /**
     * Set PaymentArrangementReceivable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PaymentArrangementReceivable[] $paymentArrangementReceivable
     * @return \SGCIS\Array\ArrayOfPaymentArrangementReceivable
     */
    public function setPaymentArrangementReceivable(array $paymentArrangementReceivable = array())
    {
        foreach ($paymentArrangementReceivable as $arrayOfPaymentArrangementReceivablePaymentArrangementReceivableItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentArrangementReceivablePaymentArrangementReceivableItem instanceof \SGCIS\Struct\PaymentArrangementReceivable) {
                throw new \InvalidArgumentException(sprintf('The PaymentArrangementReceivable property can only contain items of \SGCIS\Struct\PaymentArrangementReceivable, "%s" given', is_object($arrayOfPaymentArrangementReceivablePaymentArrangementReceivableItem) ? get_class($arrayOfPaymentArrangementReceivablePaymentArrangementReceivableItem) : gettype($arrayOfPaymentArrangementReceivablePaymentArrangementReceivableItem)), __LINE__);
            }
        }
        if (is_null($paymentArrangementReceivable) || (is_array($paymentArrangementReceivable) && empty($paymentArrangementReceivable))) {
            unset($this->PaymentArrangementReceivable);
        } else {
            $this->PaymentArrangementReceivable = $paymentArrangementReceivable;
        }
        return $this;
    }
    /**
     * Add item to PaymentArrangementReceivable value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PaymentArrangementReceivable $item
     * @return \SGCIS\Array\ArrayOfPaymentArrangementReceivable
     */
    public function addToPaymentArrangementReceivable(\SGCIS\Struct\PaymentArrangementReceivable $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\PaymentArrangementReceivable) {
            throw new \InvalidArgumentException(sprintf('The PaymentArrangementReceivable property can only contain items of \SGCIS\Struct\PaymentArrangementReceivable, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PaymentArrangementReceivable[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\PaymentArrangementReceivable|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\PaymentArrangementReceivable|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\PaymentArrangementReceivable|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\PaymentArrangementReceivable|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\PaymentArrangementReceivable|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentArrangementReceivable
     */
    public function getAttributeName()
    {
        return 'PaymentArrangementReceivable';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfPaymentArrangementReceivable
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
