<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPromotionAccountType Array
 * @subpackage Arrays
 */
class ArrayOfPromotionAccountType extends AbstractStructArrayBase
{
    /**
     * The PromotionAccountType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\PromotionAccountType[]
     */
    public $PromotionAccountType;
    /**
     * Constructor method for ArrayOfPromotionAccountType
     * @uses ArrayOfPromotionAccountType::setPromotionAccountType()
     * @param \SGCIS\Struct\PromotionAccountType[] $promotionAccountType
     */
    public function __construct(array $promotionAccountType = array())
    {
        $this
            ->setPromotionAccountType($promotionAccountType);
    }
    /**
     * Get PromotionAccountType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\PromotionAccountType[]|null
     */
    public function getPromotionAccountType()
    {
        return isset($this->PromotionAccountType) ? $this->PromotionAccountType : null;
    }
    /**
     * Set PromotionAccountType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionAccountType[] $promotionAccountType
     * @return \SGCIS\Array\ArrayOfPromotionAccountType
     */
    public function setPromotionAccountType(array $promotionAccountType = array())
    {
        foreach ($promotionAccountType as $arrayOfPromotionAccountTypePromotionAccountTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPromotionAccountTypePromotionAccountTypeItem instanceof \SGCIS\Struct\PromotionAccountType) {
                throw new \InvalidArgumentException(sprintf('The PromotionAccountType property can only contain items of \SGCIS\Struct\PromotionAccountType, "%s" given', is_object($arrayOfPromotionAccountTypePromotionAccountTypeItem) ? get_class($arrayOfPromotionAccountTypePromotionAccountTypeItem) : gettype($arrayOfPromotionAccountTypePromotionAccountTypeItem)), __LINE__);
            }
        }
        if (is_null($promotionAccountType) || (is_array($promotionAccountType) && empty($promotionAccountType))) {
            unset($this->PromotionAccountType);
        } else {
            $this->PromotionAccountType = $promotionAccountType;
        }
        return $this;
    }
    /**
     * Add item to PromotionAccountType value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionAccountType $item
     * @return \SGCIS\Array\ArrayOfPromotionAccountType
     */
    public function addToPromotionAccountType(\SGCIS\Struct\PromotionAccountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\PromotionAccountType) {
            throw new \InvalidArgumentException(sprintf('The PromotionAccountType property can only contain items of \SGCIS\Struct\PromotionAccountType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PromotionAccountType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\PromotionAccountType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\PromotionAccountType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\PromotionAccountType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\PromotionAccountType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\PromotionAccountType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PromotionAccountType
     */
    public function getAttributeName()
    {
        return 'PromotionAccountType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfPromotionAccountType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
