<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPromotionCharacteristic Array
 * @subpackage Arrays
 */
class ArrayOfPromotionCharacteristic extends AbstractStructArrayBase
{
    /**
     * The PromotionCharacteristic
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\PromotionCharacteristic[]
     */
    public $PromotionCharacteristic;
    /**
     * Constructor method for ArrayOfPromotionCharacteristic
     * @uses ArrayOfPromotionCharacteristic::setPromotionCharacteristic()
     * @param \SGCIS\Struct\PromotionCharacteristic[] $promotionCharacteristic
     */
    public function __construct(array $promotionCharacteristic = array())
    {
        $this
            ->setPromotionCharacteristic($promotionCharacteristic);
    }
    /**
     * Get PromotionCharacteristic value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\PromotionCharacteristic[]|null
     */
    public function getPromotionCharacteristic()
    {
        return isset($this->PromotionCharacteristic) ? $this->PromotionCharacteristic : null;
    }
    /**
     * Set PromotionCharacteristic value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionCharacteristic[] $promotionCharacteristic
     * @return \SGCIS\Array\ArrayOfPromotionCharacteristic
     */
    public function setPromotionCharacteristic(array $promotionCharacteristic = array())
    {
        foreach ($promotionCharacteristic as $arrayOfPromotionCharacteristicPromotionCharacteristicItem) {
            // validation for constraint: itemType
            if (!$arrayOfPromotionCharacteristicPromotionCharacteristicItem instanceof \SGCIS\Struct\PromotionCharacteristic) {
                throw new \InvalidArgumentException(sprintf('The PromotionCharacteristic property can only contain items of \SGCIS\Struct\PromotionCharacteristic, "%s" given', is_object($arrayOfPromotionCharacteristicPromotionCharacteristicItem) ? get_class($arrayOfPromotionCharacteristicPromotionCharacteristicItem) : gettype($arrayOfPromotionCharacteristicPromotionCharacteristicItem)), __LINE__);
            }
        }
        if (is_null($promotionCharacteristic) || (is_array($promotionCharacteristic) && empty($promotionCharacteristic))) {
            unset($this->PromotionCharacteristic);
        } else {
            $this->PromotionCharacteristic = $promotionCharacteristic;
        }
        return $this;
    }
    /**
     * Add item to PromotionCharacteristic value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionCharacteristic $item
     * @return \SGCIS\Array\ArrayOfPromotionCharacteristic
     */
    public function addToPromotionCharacteristic(\SGCIS\Struct\PromotionCharacteristic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\PromotionCharacteristic) {
            throw new \InvalidArgumentException(sprintf('The PromotionCharacteristic property can only contain items of \SGCIS\Struct\PromotionCharacteristic, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PromotionCharacteristic[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\PromotionCharacteristic|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\PromotionCharacteristic|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\PromotionCharacteristic|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\PromotionCharacteristic|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\PromotionCharacteristic|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PromotionCharacteristic
     */
    public function getAttributeName()
    {
        return 'PromotionCharacteristic';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfPromotionCharacteristic
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
