<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPromotionDistributionServiceProvider Array
 * @subpackage Arrays
 */
class ArrayOfPromotionDistributionServiceProvider extends AbstractStructArrayBase
{
    /**
     * The PromotionDistributionServiceProvider
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\PromotionDistributionServiceProvider[]
     */
    public $PromotionDistributionServiceProvider;
    /**
     * Constructor method for ArrayOfPromotionDistributionServiceProvider
     * @uses ArrayOfPromotionDistributionServiceProvider::setPromotionDistributionServiceProvider()
     * @param \SGCIS\Struct\PromotionDistributionServiceProvider[] $promotionDistributionServiceProvider
     */
    public function __construct(array $promotionDistributionServiceProvider = array())
    {
        $this
            ->setPromotionDistributionServiceProvider($promotionDistributionServiceProvider);
    }
    /**
     * Get PromotionDistributionServiceProvider value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider[]|null
     */
    public function getPromotionDistributionServiceProvider()
    {
        return isset($this->PromotionDistributionServiceProvider) ? $this->PromotionDistributionServiceProvider : null;
    }
    /**
     * Set PromotionDistributionServiceProvider value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionDistributionServiceProvider[] $promotionDistributionServiceProvider
     * @return \SGCIS\Array\ArrayOfPromotionDistributionServiceProvider
     */
    public function setPromotionDistributionServiceProvider(array $promotionDistributionServiceProvider = array())
    {
        foreach ($promotionDistributionServiceProvider as $arrayOfPromotionDistributionServiceProviderPromotionDistributionServiceProviderItem) {
            // validation for constraint: itemType
            if (!$arrayOfPromotionDistributionServiceProviderPromotionDistributionServiceProviderItem instanceof \SGCIS\Struct\PromotionDistributionServiceProvider) {
                throw new \InvalidArgumentException(sprintf('The PromotionDistributionServiceProvider property can only contain items of \SGCIS\Struct\PromotionDistributionServiceProvider, "%s" given', is_object($arrayOfPromotionDistributionServiceProviderPromotionDistributionServiceProviderItem) ? get_class($arrayOfPromotionDistributionServiceProviderPromotionDistributionServiceProviderItem) : gettype($arrayOfPromotionDistributionServiceProviderPromotionDistributionServiceProviderItem)), __LINE__);
            }
        }
        if (is_null($promotionDistributionServiceProvider) || (is_array($promotionDistributionServiceProvider) && empty($promotionDistributionServiceProvider))) {
            unset($this->PromotionDistributionServiceProvider);
        } else {
            $this->PromotionDistributionServiceProvider = $promotionDistributionServiceProvider;
        }
        return $this;
    }
    /**
     * Add item to PromotionDistributionServiceProvider value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\PromotionDistributionServiceProvider $item
     * @return \SGCIS\Array\ArrayOfPromotionDistributionServiceProvider
     */
    public function addToPromotionDistributionServiceProvider(\SGCIS\Struct\PromotionDistributionServiceProvider $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\PromotionDistributionServiceProvider) {
            throw new \InvalidArgumentException(sprintf('The PromotionDistributionServiceProvider property can only contain items of \SGCIS\Struct\PromotionDistributionServiceProvider, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PromotionDistributionServiceProvider[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PromotionDistributionServiceProvider
     */
    public function getAttributeName()
    {
        return 'PromotionDistributionServiceProvider';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfPromotionDistributionServiceProvider
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
