<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSystemRoleApplication Array
 * @subpackage Arrays
 */
class ArrayOfSystemRoleApplication extends AbstractStructArrayBase
{
    /**
     * The SystemRoleApplication
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\SystemRoleApplication[]
     */
    public $SystemRoleApplication;
    /**
     * Constructor method for ArrayOfSystemRoleApplication
     * @uses ArrayOfSystemRoleApplication::setSystemRoleApplication()
     * @param \SGCIS\Struct\SystemRoleApplication[] $systemRoleApplication
     */
    public function __construct(array $systemRoleApplication = array())
    {
        $this
            ->setSystemRoleApplication($systemRoleApplication);
    }
    /**
     * Get SystemRoleApplication value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\SystemRoleApplication[]|null
     */
    public function getSystemRoleApplication()
    {
        return isset($this->SystemRoleApplication) ? $this->SystemRoleApplication : null;
    }
    /**
     * Set SystemRoleApplication value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\SystemRoleApplication[] $systemRoleApplication
     * @return \SGCIS\Array\ArrayOfSystemRoleApplication
     */
    public function setSystemRoleApplication(array $systemRoleApplication = array())
    {
        foreach ($systemRoleApplication as $arrayOfSystemRoleApplicationSystemRoleApplicationItem) {
            // validation for constraint: itemType
            if (!$arrayOfSystemRoleApplicationSystemRoleApplicationItem instanceof \SGCIS\Struct\SystemRoleApplication) {
                throw new \InvalidArgumentException(sprintf('The SystemRoleApplication property can only contain items of \SGCIS\Struct\SystemRoleApplication, "%s" given', is_object($arrayOfSystemRoleApplicationSystemRoleApplicationItem) ? get_class($arrayOfSystemRoleApplicationSystemRoleApplicationItem) : gettype($arrayOfSystemRoleApplicationSystemRoleApplicationItem)), __LINE__);
            }
        }
        if (is_null($systemRoleApplication) || (is_array($systemRoleApplication) && empty($systemRoleApplication))) {
            unset($this->SystemRoleApplication);
        } else {
            $this->SystemRoleApplication = $systemRoleApplication;
        }
        return $this;
    }
    /**
     * Add item to SystemRoleApplication value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\SystemRoleApplication $item
     * @return \SGCIS\Array\ArrayOfSystemRoleApplication
     */
    public function addToSystemRoleApplication(\SGCIS\Struct\SystemRoleApplication $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\SystemRoleApplication) {
            throw new \InvalidArgumentException(sprintf('The SystemRoleApplication property can only contain items of \SGCIS\Struct\SystemRoleApplication, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SystemRoleApplication[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\SystemRoleApplication|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\SystemRoleApplication|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\SystemRoleApplication|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\SystemRoleApplication|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\SystemRoleApplication|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SystemRoleApplication
     */
    public function getAttributeName()
    {
        return 'SystemRoleApplication';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfSystemRoleApplication
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
