<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTOUChargeSchedule Array
 * @subpackage Arrays
 */
class ArrayOfTOUChargeSchedule extends AbstractStructArrayBase
{
    /**
     * The TOUChargeSchedule
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\TOUChargeSchedule[]
     */
    public $TOUChargeSchedule;
    /**
     * Constructor method for ArrayOfTOUChargeSchedule
     * @uses ArrayOfTOUChargeSchedule::setTOUChargeSchedule()
     * @param \SGCIS\Struct\TOUChargeSchedule[] $tOUChargeSchedule
     */
    public function __construct(array $tOUChargeSchedule = array())
    {
        $this
            ->setTOUChargeSchedule($tOUChargeSchedule);
    }
    /**
     * Get TOUChargeSchedule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\TOUChargeSchedule[]|null
     */
    public function getTOUChargeSchedule()
    {
        return isset($this->TOUChargeSchedule) ? $this->TOUChargeSchedule : null;
    }
    /**
     * Set TOUChargeSchedule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TOUChargeSchedule[] $tOUChargeSchedule
     * @return \SGCIS\Array\ArrayOfTOUChargeSchedule
     */
    public function setTOUChargeSchedule(array $tOUChargeSchedule = array())
    {
        foreach ($tOUChargeSchedule as $arrayOfTOUChargeScheduleTOUChargeScheduleItem) {
            // validation for constraint: itemType
            if (!$arrayOfTOUChargeScheduleTOUChargeScheduleItem instanceof \SGCIS\Struct\TOUChargeSchedule) {
                throw new \InvalidArgumentException(sprintf('The TOUChargeSchedule property can only contain items of \SGCIS\Struct\TOUChargeSchedule, "%s" given', is_object($arrayOfTOUChargeScheduleTOUChargeScheduleItem) ? get_class($arrayOfTOUChargeScheduleTOUChargeScheduleItem) : gettype($arrayOfTOUChargeScheduleTOUChargeScheduleItem)), __LINE__);
            }
        }
        if (is_null($tOUChargeSchedule) || (is_array($tOUChargeSchedule) && empty($tOUChargeSchedule))) {
            unset($this->TOUChargeSchedule);
        } else {
            $this->TOUChargeSchedule = $tOUChargeSchedule;
        }
        return $this;
    }
    /**
     * Add item to TOUChargeSchedule value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TOUChargeSchedule $item
     * @return \SGCIS\Array\ArrayOfTOUChargeSchedule
     */
    public function addToTOUChargeSchedule(\SGCIS\Struct\TOUChargeSchedule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\TOUChargeSchedule) {
            throw new \InvalidArgumentException(sprintf('The TOUChargeSchedule property can only contain items of \SGCIS\Struct\TOUChargeSchedule, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TOUChargeSchedule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\TOUChargeSchedule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\TOUChargeSchedule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\TOUChargeSchedule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\TOUChargeSchedule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\TOUChargeSchedule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TOUChargeSchedule
     */
    public function getAttributeName()
    {
        return 'TOUChargeSchedule';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfTOUChargeSchedule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
