<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketQueueType Array
 * @subpackage Arrays
 */
class ArrayOfTicketQueueType extends AbstractStructArrayBase
{
    /**
     * The TicketQueueType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\TicketQueueType[]
     */
    public $TicketQueueType;
    /**
     * Constructor method for ArrayOfTicketQueueType
     * @uses ArrayOfTicketQueueType::setTicketQueueType()
     * @param \SGCIS\Struct\TicketQueueType[] $ticketQueueType
     */
    public function __construct(array $ticketQueueType = array())
    {
        $this
            ->setTicketQueueType($ticketQueueType);
    }
    /**
     * Get TicketQueueType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\TicketQueueType[]|null
     */
    public function getTicketQueueType()
    {
        return isset($this->TicketQueueType) ? $this->TicketQueueType : null;
    }
    /**
     * Set TicketQueueType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketQueueType[] $ticketQueueType
     * @return \SGCIS\Array\ArrayOfTicketQueueType
     */
    public function setTicketQueueType(array $ticketQueueType = array())
    {
        foreach ($ticketQueueType as $arrayOfTicketQueueTypeTicketQueueTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketQueueTypeTicketQueueTypeItem instanceof \SGCIS\Struct\TicketQueueType) {
                throw new \InvalidArgumentException(sprintf('The TicketQueueType property can only contain items of \SGCIS\Struct\TicketQueueType, "%s" given', is_object($arrayOfTicketQueueTypeTicketQueueTypeItem) ? get_class($arrayOfTicketQueueTypeTicketQueueTypeItem) : gettype($arrayOfTicketQueueTypeTicketQueueTypeItem)), __LINE__);
            }
        }
        if (is_null($ticketQueueType) || (is_array($ticketQueueType) && empty($ticketQueueType))) {
            unset($this->TicketQueueType);
        } else {
            $this->TicketQueueType = $ticketQueueType;
        }
        return $this;
    }
    /**
     * Add item to TicketQueueType value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketQueueType $item
     * @return \SGCIS\Array\ArrayOfTicketQueueType
     */
    public function addToTicketQueueType(\SGCIS\Struct\TicketQueueType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\TicketQueueType) {
            throw new \InvalidArgumentException(sprintf('The TicketQueueType property can only contain items of \SGCIS\Struct\TicketQueueType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TicketQueueType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\TicketQueueType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\TicketQueueType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\TicketQueueType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\TicketQueueType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\TicketQueueType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TicketQueueType
     */
    public function getAttributeName()
    {
        return 'TicketQueueType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfTicketQueueType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
