<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketStatusHistory Array
 * @subpackage Arrays
 */
class ArrayOfTicketStatusHistory extends AbstractStructArrayBase
{
    /**
     * The TicketStatusHistory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\TicketStatusHistory[]
     */
    public $TicketStatusHistory;
    /**
     * Constructor method for ArrayOfTicketStatusHistory
     * @uses ArrayOfTicketStatusHistory::setTicketStatusHistory()
     * @param \SGCIS\Struct\TicketStatusHistory[] $ticketStatusHistory
     */
    public function __construct(array $ticketStatusHistory = array())
    {
        $this
            ->setTicketStatusHistory($ticketStatusHistory);
    }
    /**
     * Get TicketStatusHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\TicketStatusHistory[]|null
     */
    public function getTicketStatusHistory()
    {
        return isset($this->TicketStatusHistory) ? $this->TicketStatusHistory : null;
    }
    /**
     * Set TicketStatusHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketStatusHistory[] $ticketStatusHistory
     * @return \SGCIS\Array\ArrayOfTicketStatusHistory
     */
    public function setTicketStatusHistory(array $ticketStatusHistory = array())
    {
        foreach ($ticketStatusHistory as $arrayOfTicketStatusHistoryTicketStatusHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketStatusHistoryTicketStatusHistoryItem instanceof \SGCIS\Struct\TicketStatusHistory) {
                throw new \InvalidArgumentException(sprintf('The TicketStatusHistory property can only contain items of \SGCIS\Struct\TicketStatusHistory, "%s" given', is_object($arrayOfTicketStatusHistoryTicketStatusHistoryItem) ? get_class($arrayOfTicketStatusHistoryTicketStatusHistoryItem) : gettype($arrayOfTicketStatusHistoryTicketStatusHistoryItem)), __LINE__);
            }
        }
        if (is_null($ticketStatusHistory) || (is_array($ticketStatusHistory) && empty($ticketStatusHistory))) {
            unset($this->TicketStatusHistory);
        } else {
            $this->TicketStatusHistory = $ticketStatusHistory;
        }
        return $this;
    }
    /**
     * Add item to TicketStatusHistory value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketStatusHistory $item
     * @return \SGCIS\Array\ArrayOfTicketStatusHistory
     */
    public function addToTicketStatusHistory(\SGCIS\Struct\TicketStatusHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\TicketStatusHistory) {
            throw new \InvalidArgumentException(sprintf('The TicketStatusHistory property can only contain items of \SGCIS\Struct\TicketStatusHistory, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TicketStatusHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\TicketStatusHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\TicketStatusHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\TicketStatusHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\TicketStatusHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\TicketStatusHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TicketStatusHistory
     */
    public function getAttributeName()
    {
        return 'TicketStatusHistory';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfTicketStatusHistory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
