<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketTypeField Array
 * @subpackage Arrays
 */
class ArrayOfTicketTypeField extends AbstractStructArrayBase
{
    /**
     * The TicketTypeField
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\TicketTypeField[]
     */
    public $TicketTypeField;
    /**
     * Constructor method for ArrayOfTicketTypeField
     * @uses ArrayOfTicketTypeField::setTicketTypeField()
     * @param \SGCIS\Struct\TicketTypeField[] $ticketTypeField
     */
    public function __construct(array $ticketTypeField = array())
    {
        $this
            ->setTicketTypeField($ticketTypeField);
    }
    /**
     * Get TicketTypeField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\TicketTypeField[]|null
     */
    public function getTicketTypeField()
    {
        return isset($this->TicketTypeField) ? $this->TicketTypeField : null;
    }
    /**
     * Set TicketTypeField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketTypeField[] $ticketTypeField
     * @return \SGCIS\Array\ArrayOfTicketTypeField
     */
    public function setTicketTypeField(array $ticketTypeField = array())
    {
        foreach ($ticketTypeField as $arrayOfTicketTypeFieldTicketTypeFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketTypeFieldTicketTypeFieldItem instanceof \SGCIS\Struct\TicketTypeField) {
                throw new \InvalidArgumentException(sprintf('The TicketTypeField property can only contain items of \SGCIS\Struct\TicketTypeField, "%s" given', is_object($arrayOfTicketTypeFieldTicketTypeFieldItem) ? get_class($arrayOfTicketTypeFieldTicketTypeFieldItem) : gettype($arrayOfTicketTypeFieldTicketTypeFieldItem)), __LINE__);
            }
        }
        if (is_null($ticketTypeField) || (is_array($ticketTypeField) && empty($ticketTypeField))) {
            unset($this->TicketTypeField);
        } else {
            $this->TicketTypeField = $ticketTypeField;
        }
        return $this;
    }
    /**
     * Add item to TicketTypeField value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TicketTypeField $item
     * @return \SGCIS\Array\ArrayOfTicketTypeField
     */
    public function addToTicketTypeField(\SGCIS\Struct\TicketTypeField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\TicketTypeField) {
            throw new \InvalidArgumentException(sprintf('The TicketTypeField property can only contain items of \SGCIS\Struct\TicketTypeField, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TicketTypeField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\TicketTypeField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\TicketTypeField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\TicketTypeField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\TicketTypeField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\TicketTypeField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TicketTypeField
     */
    public function getAttributeName()
    {
        return 'TicketTypeField';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfTicketTypeField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
