<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransactionNotImported Array
 * @subpackage Arrays
 */
class ArrayOfTransactionNotImported extends AbstractStructArrayBase
{
    /**
     * The TransactionNotImported
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\TransactionNotImported[]
     */
    public $TransactionNotImported;
    /**
     * Constructor method for ArrayOfTransactionNotImported
     * @uses ArrayOfTransactionNotImported::setTransactionNotImported()
     * @param \SGCIS\Struct\TransactionNotImported[] $transactionNotImported
     */
    public function __construct(array $transactionNotImported = array())
    {
        $this
            ->setTransactionNotImported($transactionNotImported);
    }
    /**
     * Get TransactionNotImported value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\TransactionNotImported[]|null
     */
    public function getTransactionNotImported()
    {
        return isset($this->TransactionNotImported) ? $this->TransactionNotImported : null;
    }
    /**
     * Set TransactionNotImported value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TransactionNotImported[] $transactionNotImported
     * @return \SGCIS\Array\ArrayOfTransactionNotImported
     */
    public function setTransactionNotImported(array $transactionNotImported = array())
    {
        foreach ($transactionNotImported as $arrayOfTransactionNotImportedTransactionNotImportedItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransactionNotImportedTransactionNotImportedItem instanceof \SGCIS\Struct\TransactionNotImported) {
                throw new \InvalidArgumentException(sprintf('The TransactionNotImported property can only contain items of \SGCIS\Struct\TransactionNotImported, "%s" given', is_object($arrayOfTransactionNotImportedTransactionNotImportedItem) ? get_class($arrayOfTransactionNotImportedTransactionNotImportedItem) : gettype($arrayOfTransactionNotImportedTransactionNotImportedItem)), __LINE__);
            }
        }
        if (is_null($transactionNotImported) || (is_array($transactionNotImported) && empty($transactionNotImported))) {
            unset($this->TransactionNotImported);
        } else {
            $this->TransactionNotImported = $transactionNotImported;
        }
        return $this;
    }
    /**
     * Add item to TransactionNotImported value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\TransactionNotImported $item
     * @return \SGCIS\Array\ArrayOfTransactionNotImported
     */
    public function addToTransactionNotImported(\SGCIS\Struct\TransactionNotImported $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\TransactionNotImported) {
            throw new \InvalidArgumentException(sprintf('The TransactionNotImported property can only contain items of \SGCIS\Struct\TransactionNotImported, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TransactionNotImported[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\TransactionNotImported|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\TransactionNotImported|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\TransactionNotImported|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\TransactionNotImported|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\TransactionNotImported|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransactionNotImported
     */
    public function getAttributeName()
    {
        return 'TransactionNotImported';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfTransactionNotImported
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
