<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUsageChargeAccountType Array
 * @subpackage Arrays
 */
class ArrayOfUsageChargeAccountType extends AbstractStructArrayBase
{
    /**
     * The UsageChargeAccountType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\UsageChargeAccountType[]
     */
    public $UsageChargeAccountType;
    /**
     * Constructor method for ArrayOfUsageChargeAccountType
     * @uses ArrayOfUsageChargeAccountType::setUsageChargeAccountType()
     * @param \SGCIS\Struct\UsageChargeAccountType[] $usageChargeAccountType
     */
    public function __construct(array $usageChargeAccountType = array())
    {
        $this
            ->setUsageChargeAccountType($usageChargeAccountType);
    }
    /**
     * Get UsageChargeAccountType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\UsageChargeAccountType[]|null
     */
    public function getUsageChargeAccountType()
    {
        return isset($this->UsageChargeAccountType) ? $this->UsageChargeAccountType : null;
    }
    /**
     * Set UsageChargeAccountType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\UsageChargeAccountType[] $usageChargeAccountType
     * @return \SGCIS\Array\ArrayOfUsageChargeAccountType
     */
    public function setUsageChargeAccountType(array $usageChargeAccountType = array())
    {
        foreach ($usageChargeAccountType as $arrayOfUsageChargeAccountTypeUsageChargeAccountTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfUsageChargeAccountTypeUsageChargeAccountTypeItem instanceof \SGCIS\Struct\UsageChargeAccountType) {
                throw new \InvalidArgumentException(sprintf('The UsageChargeAccountType property can only contain items of \SGCIS\Struct\UsageChargeAccountType, "%s" given', is_object($arrayOfUsageChargeAccountTypeUsageChargeAccountTypeItem) ? get_class($arrayOfUsageChargeAccountTypeUsageChargeAccountTypeItem) : gettype($arrayOfUsageChargeAccountTypeUsageChargeAccountTypeItem)), __LINE__);
            }
        }
        if (is_null($usageChargeAccountType) || (is_array($usageChargeAccountType) && empty($usageChargeAccountType))) {
            unset($this->UsageChargeAccountType);
        } else {
            $this->UsageChargeAccountType = $usageChargeAccountType;
        }
        return $this;
    }
    /**
     * Add item to UsageChargeAccountType value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\UsageChargeAccountType $item
     * @return \SGCIS\Array\ArrayOfUsageChargeAccountType
     */
    public function addToUsageChargeAccountType(\SGCIS\Struct\UsageChargeAccountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\UsageChargeAccountType) {
            throw new \InvalidArgumentException(sprintf('The UsageChargeAccountType property can only contain items of \SGCIS\Struct\UsageChargeAccountType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UsageChargeAccountType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\UsageChargeAccountType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\UsageChargeAccountType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\UsageChargeAccountType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\UsageChargeAccountType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\UsageChargeAccountType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UsageChargeAccountType
     */
    public function getAttributeName()
    {
        return 'UsageChargeAccountType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfUsageChargeAccountType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
