<?php

namespace SGCIS\Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVEEValidationRule Array
 * @subpackage Arrays
 */
class ArrayOfVEEValidationRule extends AbstractStructArrayBase
{
    /**
     * The VEEValidationRule
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \SGCIS\Struct\VEEValidationRule[]
     */
    public $VEEValidationRule;
    /**
     * Constructor method for ArrayOfVEEValidationRule
     * @uses ArrayOfVEEValidationRule::setVEEValidationRule()
     * @param \SGCIS\Struct\VEEValidationRule[] $vEEValidationRule
     */
    public function __construct(array $vEEValidationRule = array())
    {
        $this
            ->setVEEValidationRule($vEEValidationRule);
    }
    /**
     * Get VEEValidationRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \SGCIS\Struct\VEEValidationRule[]|null
     */
    public function getVEEValidationRule()
    {
        return isset($this->VEEValidationRule) ? $this->VEEValidationRule : null;
    }
    /**
     * Set VEEValidationRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\VEEValidationRule[] $vEEValidationRule
     * @return \SGCIS\Array\ArrayOfVEEValidationRule
     */
    public function setVEEValidationRule(array $vEEValidationRule = array())
    {
        foreach ($vEEValidationRule as $arrayOfVEEValidationRuleVEEValidationRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfVEEValidationRuleVEEValidationRuleItem instanceof \SGCIS\Struct\VEEValidationRule) {
                throw new \InvalidArgumentException(sprintf('The VEEValidationRule property can only contain items of \SGCIS\Struct\VEEValidationRule, "%s" given', is_object($arrayOfVEEValidationRuleVEEValidationRuleItem) ? get_class($arrayOfVEEValidationRuleVEEValidationRuleItem) : gettype($arrayOfVEEValidationRuleVEEValidationRuleItem)), __LINE__);
            }
        }
        if (is_null($vEEValidationRule) || (is_array($vEEValidationRule) && empty($vEEValidationRule))) {
            unset($this->VEEValidationRule);
        } else {
            $this->VEEValidationRule = $vEEValidationRule;
        }
        return $this;
    }
    /**
     * Add item to VEEValidationRule value
     * @throws \InvalidArgumentException
     * @param \SGCIS\Struct\VEEValidationRule $item
     * @return \SGCIS\Array\ArrayOfVEEValidationRule
     */
    public function addToVEEValidationRule(\SGCIS\Struct\VEEValidationRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SGCIS\Struct\VEEValidationRule) {
            throw new \InvalidArgumentException(sprintf('The VEEValidationRule property can only contain items of \SGCIS\Struct\VEEValidationRule, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VEEValidationRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \SGCIS\Struct\VEEValidationRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \SGCIS\Struct\VEEValidationRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \SGCIS\Struct\VEEValidationRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \SGCIS\Struct\VEEValidationRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \SGCIS\Struct\VEEValidationRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VEEValidationRule
     */
    public function getAttributeName()
    {
        return 'VEEValidationRule';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Array\ArrayOfVEEValidationRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
