<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BillServicePointBillingException Struct
 * @subpackage Structs
 */
class BillServicePointBillingException extends AbstractStructBase
{
    /**
     * The BillBillingExceptionID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $BillBillingExceptionID;
    /**
     * The BillServicePointID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $BillServicePointID;
    /**
     * The BillingExceptionID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $BillingExceptionID;
    /**
     * The CreateDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreateDate;
    /**
     * Constructor method for BillServicePointBillingException
     * @uses BillServicePointBillingException::setBillBillingExceptionID()
     * @uses BillServicePointBillingException::setBillServicePointID()
     * @uses BillServicePointBillingException::setBillingExceptionID()
     * @uses BillServicePointBillingException::setCreateDate()
     * @param int $billBillingExceptionID
     * @param int $billServicePointID
     * @param int $billingExceptionID
     * @param string $createDate
     */
    public function __construct($billBillingExceptionID = null, $billServicePointID = null, $billingExceptionID = null, $createDate = null)
    {
        $this
            ->setBillBillingExceptionID($billBillingExceptionID)
            ->setBillServicePointID($billServicePointID)
            ->setBillingExceptionID($billingExceptionID)
            ->setCreateDate($createDate);
    }
    /**
     * Get BillBillingExceptionID value
     * @return int
     */
    public function getBillBillingExceptionID()
    {
        return $this->BillBillingExceptionID;
    }
    /**
     * Set BillBillingExceptionID value
     * @param int $billBillingExceptionID
     * @return \SGCIS\Struct\BillServicePointBillingException
     */
    public function setBillBillingExceptionID($billBillingExceptionID = null)
    {
        // validation for constraint: int
        if (!is_null($billBillingExceptionID) && !is_numeric($billBillingExceptionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($billBillingExceptionID)), __LINE__);
        }
        $this->BillBillingExceptionID = $billBillingExceptionID;
        return $this;
    }
    /**
     * Get BillServicePointID value
     * @return int
     */
    public function getBillServicePointID()
    {
        return $this->BillServicePointID;
    }
    /**
     * Set BillServicePointID value
     * @param int $billServicePointID
     * @return \SGCIS\Struct\BillServicePointBillingException
     */
    public function setBillServicePointID($billServicePointID = null)
    {
        // validation for constraint: int
        if (!is_null($billServicePointID) && !is_numeric($billServicePointID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($billServicePointID)), __LINE__);
        }
        $this->BillServicePointID = $billServicePointID;
        return $this;
    }
    /**
     * Get BillingExceptionID value
     * @return int
     */
    public function getBillingExceptionID()
    {
        return $this->BillingExceptionID;
    }
    /**
     * Set BillingExceptionID value
     * @param int $billingExceptionID
     * @return \SGCIS\Struct\BillServicePointBillingException
     */
    public function setBillingExceptionID($billingExceptionID = null)
    {
        // validation for constraint: int
        if (!is_null($billingExceptionID) && !is_numeric($billingExceptionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($billingExceptionID)), __LINE__);
        }
        $this->BillingExceptionID = $billingExceptionID;
        return $this;
    }
    /**
     * Get CreateDate value
     * @return string
     */
    public function getCreateDate()
    {
        return $this->CreateDate;
    }
    /**
     * Set CreateDate value
     * @param string $createDate
     * @return \SGCIS\Struct\BillServicePointBillingException
     */
    public function setCreateDate($createDate = null)
    {
        // validation for constraint: string
        if (!is_null($createDate) && !is_string($createDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createDate)), __LINE__);
        }
        $this->CreateDate = $createDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\BillServicePointBillingException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
