<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromotionDistributionServiceProvider Struct
 * @subpackage Structs
 */
class PromotionDistributionServiceProvider extends AbstractStructBase
{
    /**
     * The PromotionDistributionServiceProviderID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PromotionDistributionServiceProviderID;
    /**
     * The PromotionID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PromotionID;
    /**
     * The DistributionServiceProviderID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $DistributionServiceProviderID;
    /**
     * Constructor method for PromotionDistributionServiceProvider
     * @uses PromotionDistributionServiceProvider::setPromotionDistributionServiceProviderID()
     * @uses PromotionDistributionServiceProvider::setPromotionID()
     * @uses PromotionDistributionServiceProvider::setDistributionServiceProviderID()
     * @param int $promotionDistributionServiceProviderID
     * @param int $promotionID
     * @param int $distributionServiceProviderID
     */
    public function __construct($promotionDistributionServiceProviderID = null, $promotionID = null, $distributionServiceProviderID = null)
    {
        $this
            ->setPromotionDistributionServiceProviderID($promotionDistributionServiceProviderID)
            ->setPromotionID($promotionID)
            ->setDistributionServiceProviderID($distributionServiceProviderID);
    }
    /**
     * Get PromotionDistributionServiceProviderID value
     * @return int
     */
    public function getPromotionDistributionServiceProviderID()
    {
        return $this->PromotionDistributionServiceProviderID;
    }
    /**
     * Set PromotionDistributionServiceProviderID value
     * @param int $promotionDistributionServiceProviderID
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider
     */
    public function setPromotionDistributionServiceProviderID($promotionDistributionServiceProviderID = null)
    {
        // validation for constraint: int
        if (!is_null($promotionDistributionServiceProviderID) && !is_numeric($promotionDistributionServiceProviderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($promotionDistributionServiceProviderID)), __LINE__);
        }
        $this->PromotionDistributionServiceProviderID = $promotionDistributionServiceProviderID;
        return $this;
    }
    /**
     * Get PromotionID value
     * @return int
     */
    public function getPromotionID()
    {
        return $this->PromotionID;
    }
    /**
     * Set PromotionID value
     * @param int $promotionID
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider
     */
    public function setPromotionID($promotionID = null)
    {
        // validation for constraint: int
        if (!is_null($promotionID) && !is_numeric($promotionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($promotionID)), __LINE__);
        }
        $this->PromotionID = $promotionID;
        return $this;
    }
    /**
     * Get DistributionServiceProviderID value
     * @return int
     */
    public function getDistributionServiceProviderID()
    {
        return $this->DistributionServiceProviderID;
    }
    /**
     * Set DistributionServiceProviderID value
     * @param int $distributionServiceProviderID
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider
     */
    public function setDistributionServiceProviderID($distributionServiceProviderID = null)
    {
        // validation for constraint: int
        if (!is_null($distributionServiceProviderID) && !is_numeric($distributionServiceProviderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($distributionServiceProviderID)), __LINE__);
        }
        $this->DistributionServiceProviderID = $distributionServiceProviderID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\PromotionDistributionServiceProvider
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
