<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromotionScheduleSpecificDay Struct
 * @subpackage Structs
 */
class PromotionScheduleSpecificDay extends AbstractStructBase
{
    /**
     * The PromotionScheduleSpecificDayID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PromotionScheduleSpecificDayID;
    /**
     * The PromotionID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PromotionID;
    /**
     * The SpecificDay
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SpecificDay;
    /**
     * The CreateDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreateDate;
    /**
     * Constructor method for PromotionScheduleSpecificDay
     * @uses PromotionScheduleSpecificDay::setPromotionScheduleSpecificDayID()
     * @uses PromotionScheduleSpecificDay::setPromotionID()
     * @uses PromotionScheduleSpecificDay::setSpecificDay()
     * @uses PromotionScheduleSpecificDay::setCreateDate()
     * @param int $promotionScheduleSpecificDayID
     * @param int $promotionID
     * @param string $specificDay
     * @param string $createDate
     */
    public function __construct($promotionScheduleSpecificDayID = null, $promotionID = null, $specificDay = null, $createDate = null)
    {
        $this
            ->setPromotionScheduleSpecificDayID($promotionScheduleSpecificDayID)
            ->setPromotionID($promotionID)
            ->setSpecificDay($specificDay)
            ->setCreateDate($createDate);
    }
    /**
     * Get PromotionScheduleSpecificDayID value
     * @return int
     */
    public function getPromotionScheduleSpecificDayID()
    {
        return $this->PromotionScheduleSpecificDayID;
    }
    /**
     * Set PromotionScheduleSpecificDayID value
     * @param int $promotionScheduleSpecificDayID
     * @return \SGCIS\Struct\PromotionScheduleSpecificDay
     */
    public function setPromotionScheduleSpecificDayID($promotionScheduleSpecificDayID = null)
    {
        // validation for constraint: int
        if (!is_null($promotionScheduleSpecificDayID) && !is_numeric($promotionScheduleSpecificDayID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($promotionScheduleSpecificDayID)), __LINE__);
        }
        $this->PromotionScheduleSpecificDayID = $promotionScheduleSpecificDayID;
        return $this;
    }
    /**
     * Get PromotionID value
     * @return int
     */
    public function getPromotionID()
    {
        return $this->PromotionID;
    }
    /**
     * Set PromotionID value
     * @param int $promotionID
     * @return \SGCIS\Struct\PromotionScheduleSpecificDay
     */
    public function setPromotionID($promotionID = null)
    {
        // validation for constraint: int
        if (!is_null($promotionID) && !is_numeric($promotionID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($promotionID)), __LINE__);
        }
        $this->PromotionID = $promotionID;
        return $this;
    }
    /**
     * Get SpecificDay value
     * @return string
     */
    public function getSpecificDay()
    {
        return $this->SpecificDay;
    }
    /**
     * Set SpecificDay value
     * @param string $specificDay
     * @return \SGCIS\Struct\PromotionScheduleSpecificDay
     */
    public function setSpecificDay($specificDay = null)
    {
        // validation for constraint: string
        if (!is_null($specificDay) && !is_string($specificDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($specificDay)), __LINE__);
        }
        $this->SpecificDay = $specificDay;
        return $this;
    }
    /**
     * Get CreateDate value
     * @return string
     */
    public function getCreateDate()
    {
        return $this->CreateDate;
    }
    /**
     * Set CreateDate value
     * @param string $createDate
     * @return \SGCIS\Struct\PromotionScheduleSpecificDay
     */
    public function setCreateDate($createDate = null)
    {
        // validation for constraint: string
        if (!is_null($createDate) && !is_string($createDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createDate)), __LINE__);
        }
        $this->CreateDate = $createDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\PromotionScheduleSpecificDay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
