<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RateTariffCharge Struct
 * @subpackage Structs
 */
class RateTariffCharge extends BaseDTO
{
    /**
     * The RateTarrifChargeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $RateTarrifChargeID;
    /**
     * The RateID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $RateID;
    /**
     * The TarrifChargeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TarrifChargeID;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * Constructor method for RateTariffCharge
     * @uses RateTariffCharge::setRateTarrifChargeID()
     * @uses RateTariffCharge::setRateID()
     * @uses RateTariffCharge::setTarrifChargeID()
     * @uses RateTariffCharge::setName()
     * @param int $rateTarrifChargeID
     * @param int $rateID
     * @param int $tarrifChargeID
     * @param string $name
     */
    public function __construct($rateTarrifChargeID = null, $rateID = null, $tarrifChargeID = null, $name = null)
    {
        $this
            ->setRateTarrifChargeID($rateTarrifChargeID)
            ->setRateID($rateID)
            ->setTarrifChargeID($tarrifChargeID)
            ->setName($name);
    }
    /**
     * Get RateTarrifChargeID value
     * @return int
     */
    public function getRateTarrifChargeID()
    {
        return $this->RateTarrifChargeID;
    }
    /**
     * Set RateTarrifChargeID value
     * @param int $rateTarrifChargeID
     * @return \SGCIS\Struct\RateTariffCharge
     */
    public function setRateTarrifChargeID($rateTarrifChargeID = null)
    {
        // validation for constraint: int
        if (!is_null($rateTarrifChargeID) && !is_numeric($rateTarrifChargeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($rateTarrifChargeID)), __LINE__);
        }
        $this->RateTarrifChargeID = $rateTarrifChargeID;
        return $this;
    }
    /**
     * Get RateID value
     * @return int
     */
    public function getRateID()
    {
        return $this->RateID;
    }
    /**
     * Set RateID value
     * @param int $rateID
     * @return \SGCIS\Struct\RateTariffCharge
     */
    public function setRateID($rateID = null)
    {
        // validation for constraint: int
        if (!is_null($rateID) && !is_numeric($rateID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($rateID)), __LINE__);
        }
        $this->RateID = $rateID;
        return $this;
    }
    /**
     * Get TarrifChargeID value
     * @return int
     */
    public function getTarrifChargeID()
    {
        return $this->TarrifChargeID;
    }
    /**
     * Set TarrifChargeID value
     * @param int $tarrifChargeID
     * @return \SGCIS\Struct\RateTariffCharge
     */
    public function setTarrifChargeID($tarrifChargeID = null)
    {
        // validation for constraint: int
        if (!is_null($tarrifChargeID) && !is_numeric($tarrifChargeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($tarrifChargeID)), __LINE__);
        }
        $this->TarrifChargeID = $tarrifChargeID;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \SGCIS\Struct\RateTariffCharge
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\RateTariffCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
