<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SystemPropertyResponse Struct
 * @subpackage Structs
 */
class SystemPropertyResponse extends ServiceResponseBase
{
    /**
     * The SystemProperties
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \SGCIS\Array\ArrayOfSystemProperty
     */
    public $SystemProperties;
    /**
     * The SystemProperty
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \SGCIS\Struct\SystemProperty
     */
    public $SystemProperty;
    /**
     * Constructor method for SystemPropertyResponse
     * @uses SystemPropertyResponse::setSystemProperties()
     * @uses SystemPropertyResponse::setSystemProperty()
     * @param \SGCIS\Array\ArrayOfSystemProperty $systemProperties
     * @param \SGCIS\Struct\SystemProperty $systemProperty
     */
    public function __construct(\SGCIS\Array\ArrayOfSystemProperty $systemProperties = null, \SGCIS\Struct\SystemProperty $systemProperty = null)
    {
        $this
            ->setSystemProperties($systemProperties)
            ->setSystemProperty($systemProperty);
    }
    /**
     * Get SystemProperties value
     * @return \SGCIS\Array\ArrayOfSystemProperty|null
     */
    public function getSystemProperties()
    {
        return $this->SystemProperties;
    }
    /**
     * Set SystemProperties value
     * @param \SGCIS\Array\ArrayOfSystemProperty $systemProperties
     * @return \SGCIS\Struct\SystemPropertyResponse
     */
    public function setSystemProperties(\SGCIS\Array\ArrayOfSystemProperty $systemProperties = null)
    {
        $this->SystemProperties = $systemProperties;
        return $this;
    }
    /**
     * Get SystemProperty value
     * @return \SGCIS\Struct\SystemProperty|null
     */
    public function getSystemProperty()
    {
        return $this->SystemProperty;
    }
    /**
     * Set SystemProperty value
     * @param \SGCIS\Struct\SystemProperty $systemProperty
     * @return \SGCIS\Struct\SystemPropertyResponse
     */
    public function setSystemProperty(\SGCIS\Struct\SystemProperty $systemProperty = null)
    {
        $this->SystemProperty = $systemProperty;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\SystemPropertyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
