<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TicketTypeField Struct
 * @subpackage Structs
 */
class TicketTypeField extends AbstractStructBase
{
    /**
     * The TicketTypeFieldID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TicketTypeFieldID;
    /**
     * The TicketTypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TicketTypeID;
    /**
     * The TicketFieldID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TicketFieldID;
    /**
     * The IsRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsRequired;
    /**
     * The MaxFieldLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MaxFieldLength;
    /**
     * The MinFieldLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MinFieldLength;
    /**
     * The DisplayOrder
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $DisplayOrder;
    /**
     * The IsDBRecord
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsDBRecord;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * Constructor method for TicketTypeField
     * @uses TicketTypeField::setTicketTypeFieldID()
     * @uses TicketTypeField::setTicketTypeID()
     * @uses TicketTypeField::setTicketFieldID()
     * @uses TicketTypeField::setIsRequired()
     * @uses TicketTypeField::setMaxFieldLength()
     * @uses TicketTypeField::setMinFieldLength()
     * @uses TicketTypeField::setDisplayOrder()
     * @uses TicketTypeField::setIsDBRecord()
     * @uses TicketTypeField::setName()
     * @uses TicketTypeField::setDescription()
     * @param int $ticketTypeFieldID
     * @param int $ticketTypeID
     * @param int $ticketFieldID
     * @param bool $isRequired
     * @param int $maxFieldLength
     * @param int $minFieldLength
     * @param int $displayOrder
     * @param bool $isDBRecord
     * @param string $name
     * @param string $description
     */
    public function __construct($ticketTypeFieldID = null, $ticketTypeID = null, $ticketFieldID = null, $isRequired = null, $maxFieldLength = null, $minFieldLength = null, $displayOrder = null, $isDBRecord = null, $name = null, $description = null)
    {
        $this
            ->setTicketTypeFieldID($ticketTypeFieldID)
            ->setTicketTypeID($ticketTypeID)
            ->setTicketFieldID($ticketFieldID)
            ->setIsRequired($isRequired)
            ->setMaxFieldLength($maxFieldLength)
            ->setMinFieldLength($minFieldLength)
            ->setDisplayOrder($displayOrder)
            ->setIsDBRecord($isDBRecord)
            ->setName($name)
            ->setDescription($description);
    }
    /**
     * Get TicketTypeFieldID value
     * @return int
     */
    public function getTicketTypeFieldID()
    {
        return $this->TicketTypeFieldID;
    }
    /**
     * Set TicketTypeFieldID value
     * @param int $ticketTypeFieldID
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setTicketTypeFieldID($ticketTypeFieldID = null)
    {
        // validation for constraint: int
        if (!is_null($ticketTypeFieldID) && !is_numeric($ticketTypeFieldID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ticketTypeFieldID)), __LINE__);
        }
        $this->TicketTypeFieldID = $ticketTypeFieldID;
        return $this;
    }
    /**
     * Get TicketTypeID value
     * @return int
     */
    public function getTicketTypeID()
    {
        return $this->TicketTypeID;
    }
    /**
     * Set TicketTypeID value
     * @param int $ticketTypeID
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setTicketTypeID($ticketTypeID = null)
    {
        // validation for constraint: int
        if (!is_null($ticketTypeID) && !is_numeric($ticketTypeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ticketTypeID)), __LINE__);
        }
        $this->TicketTypeID = $ticketTypeID;
        return $this;
    }
    /**
     * Get TicketFieldID value
     * @return int
     */
    public function getTicketFieldID()
    {
        return $this->TicketFieldID;
    }
    /**
     * Set TicketFieldID value
     * @param int $ticketFieldID
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setTicketFieldID($ticketFieldID = null)
    {
        // validation for constraint: int
        if (!is_null($ticketFieldID) && !is_numeric($ticketFieldID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ticketFieldID)), __LINE__);
        }
        $this->TicketFieldID = $ticketFieldID;
        return $this;
    }
    /**
     * Get IsRequired value
     * @return bool
     */
    public function getIsRequired()
    {
        return $this->IsRequired;
    }
    /**
     * Set IsRequired value
     * @param bool $isRequired
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setIsRequired($isRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($isRequired) && !is_bool($isRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isRequired)), __LINE__);
        }
        $this->IsRequired = $isRequired;
        return $this;
    }
    /**
     * Get MaxFieldLength value
     * @return int
     */
    public function getMaxFieldLength()
    {
        return $this->MaxFieldLength;
    }
    /**
     * Set MaxFieldLength value
     * @param int $maxFieldLength
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setMaxFieldLength($maxFieldLength = null)
    {
        // validation for constraint: int
        if (!is_null($maxFieldLength) && !is_numeric($maxFieldLength)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maxFieldLength)), __LINE__);
        }
        $this->MaxFieldLength = $maxFieldLength;
        return $this;
    }
    /**
     * Get MinFieldLength value
     * @return int
     */
    public function getMinFieldLength()
    {
        return $this->MinFieldLength;
    }
    /**
     * Set MinFieldLength value
     * @param int $minFieldLength
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setMinFieldLength($minFieldLength = null)
    {
        // validation for constraint: int
        if (!is_null($minFieldLength) && !is_numeric($minFieldLength)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($minFieldLength)), __LINE__);
        }
        $this->MinFieldLength = $minFieldLength;
        return $this;
    }
    /**
     * Get DisplayOrder value
     * @return int
     */
    public function getDisplayOrder()
    {
        return $this->DisplayOrder;
    }
    /**
     * Set DisplayOrder value
     * @param int $displayOrder
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setDisplayOrder($displayOrder = null)
    {
        // validation for constraint: int
        if (!is_null($displayOrder) && !is_numeric($displayOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($displayOrder)), __LINE__);
        }
        $this->DisplayOrder = $displayOrder;
        return $this;
    }
    /**
     * Get IsDBRecord value
     * @return bool
     */
    public function getIsDBRecord()
    {
        return $this->IsDBRecord;
    }
    /**
     * Set IsDBRecord value
     * @param bool $isDBRecord
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setIsDBRecord($isDBRecord = null)
    {
        // validation for constraint: boolean
        if (!is_null($isDBRecord) && !is_bool($isDBRecord)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isDBRecord)), __LINE__);
        }
        $this->IsDBRecord = $isDBRecord;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \SGCIS\Struct\TicketTypeField
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\TicketTypeField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
