<?php

namespace SGCIS\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateEnrollmentLocationsRequest Struct
 * @subpackage Structs
 */
class ValidateEnrollmentLocationsRequest extends ServiceRequestBase
{
    /**
     * The ToSkipSwitchHoldValidation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ToSkipSwitchHoldValidation;
    /**
     * The DistributionPoints
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \SGCIS\Array\ArrayOfDistributionPoint
     */
    public $DistributionPoints;
    /**
     * Constructor method for ValidateEnrollmentLocationsRequest
     * @uses ValidateEnrollmentLocationsRequest::setToSkipSwitchHoldValidation()
     * @uses ValidateEnrollmentLocationsRequest::setDistributionPoints()
     * @param bool $toSkipSwitchHoldValidation
     * @param \SGCIS\Array\ArrayOfDistributionPoint $distributionPoints
     */
    public function __construct($toSkipSwitchHoldValidation = null, \SGCIS\Array\ArrayOfDistributionPoint $distributionPoints = null)
    {
        $this
            ->setToSkipSwitchHoldValidation($toSkipSwitchHoldValidation)
            ->setDistributionPoints($distributionPoints);
    }
    /**
     * Get ToSkipSwitchHoldValidation value
     * @return bool
     */
    public function getToSkipSwitchHoldValidation()
    {
        return $this->ToSkipSwitchHoldValidation;
    }
    /**
     * Set ToSkipSwitchHoldValidation value
     * @param bool $toSkipSwitchHoldValidation
     * @return \SGCIS\Struct\ValidateEnrollmentLocationsRequest
     */
    public function setToSkipSwitchHoldValidation($toSkipSwitchHoldValidation = null)
    {
        // validation for constraint: boolean
        if (!is_null($toSkipSwitchHoldValidation) && !is_bool($toSkipSwitchHoldValidation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($toSkipSwitchHoldValidation)), __LINE__);
        }
        $this->ToSkipSwitchHoldValidation = $toSkipSwitchHoldValidation;
        return $this;
    }
    /**
     * Get DistributionPoints value
     * @return \SGCIS\Array\ArrayOfDistributionPoint|null
     */
    public function getDistributionPoints()
    {
        return $this->DistributionPoints;
    }
    /**
     * Set DistributionPoints value
     * @param \SGCIS\Array\ArrayOfDistributionPoint $distributionPoints
     * @return \SGCIS\Struct\ValidateEnrollmentLocationsRequest
     */
    public function setDistributionPoints(\SGCIS\Array\ArrayOfDistributionPoint $distributionPoints = null)
    {
        $this->DistributionPoints = $distributionPoints;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \SGCIS\Struct\ValidateEnrollmentLocationsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
